Subject: Re: [PATCH] vhost: Add polling mode

From: "Michael S. Tsirkin" <[email-masked]>
Date: Wed, 13 Aug 2014 14:15:50 +0200

On Tue, Aug 12, 2014 at 01:57:05PM +0300, Razya Ladelsky wrote:
> "Michael S. Tsirkin" <[email-masked]> wrote on 12/08/2014 12:18:50 PM:
> 
> > From: "Michael S. Tsirkin" <[email-masked]>
> > To: David Miller <[email-masked]>
> > Cc: Razya Ladelsky/Haifa/IBM@IBMIL, [email-masked], Alex 
> > Glikson/Haifa/IBM@IBMIL, Eran Raichstein/Haifa/IBM@IBMIL, Yossi 
> > Kuperman1/Haifa/IBM@IBMIL, Joel Nider/Haifa/IBM@IBMIL, 
> > [email-masked], [email-masked], 
> > [email-masked], [email-masked]
> > Date: 12/08/2014 12:18 PM
> > Subject: Re: [PATCH] vhost: Add polling mode
> > 
> > On Mon, Aug 11, 2014 at 12:46:21PM -0700, David Miller wrote:
> > > From: "Michael S. Tsirkin" <[email-masked]>
> > > Date: Sun, 10 Aug 2014 21:45:59 +0200
> > > 
> > > > On Sun, Aug 10, 2014 at 11:30:35AM +0300, Razya Ladelsky wrote:
> > >  ...
> > > > And, did your tests actually produce 100% load on both host CPUs?
> > >  ...
> > > 
> > > Michael, please do not quote an entire patch just to ask a one line
> > > question.
> > > 
> > > I truly, truly, wish it was simpler in modern email clients to delete
> > > the unrelated quoted material because I bet when people do this they
> > > are simply being lazy.
> > > 
> > > Thank you.
> > 
> > Lazy - mea culpa, though I'm using mutt so it isn't even hard.
> > 
> > The question still stands: the test results are only valid
> > if CPU was at 100% in all configurations.
> > This is the reason I generally prefer it when people report
> > throughput divided by CPU (power would be good too but it still
> > isn't easy for people to get that number).
> > 
> 
> Hi Michael,
> 
> Sorry for the delay, had some problems with my mailbox, and I realized 
> just now that 
> my reply wasn't sent.
> The vm indeed ALWAYS utilized 100% cpu, whether polling was enabled or 
> not.
> The vhost thread utilized less than 100% (of the other cpu) when polling 
> was disabled.
> Enabling polling increased its utilization to 100% (in which case both 
> cpus were 100% utilized). 

Hmm this means the testing wasn't successful then, as you said:

	The idea was to get it 100% loaded, so we can see that the polling is
	getting it to produce higher throughput.

in fact here you are producing more throughput but spending more power
to produce it, which can have any number of explanations besides polling
improving the efficiency. For example, increasing system load might
disable host power management.

> > -- 
> > MST